/*******************************************************************************
 * Copyright (c) 2006 Oracle Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Cameron Bateman/Oracle - initial API and implementation
 *    
 ********************************************************************************/

package org.eclipse.jst.jsf.validation.internal.el;

import java.text.MessageFormat;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.contentassist.ICompletionProposal;
import org.eclipse.jface.text.contentassist.IContextInformation;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;

/**
 * @author cbateman
 *
 */
public class ELContentAssistProposal implements ICompletionProposal {

	private final String 		_messageText;
	//private final IProject   	_project;
	
	/**
	 * @param messageText
	 * @param project
	 */
	public ELContentAssistProposal(String messageText)
	{
		_messageText = messageText;
		//_project = project;
	}
	
	public void apply(IDocument document) 
	{
//		IStructuredModel model = null;
//		
//		try
//		{
//			try
//			{
//				final IFile  facesConfigFile = (IFile) _project.findMember("WebContent/WEB-INF/faces-config.xml");
//				model = StructuredModelManager.getModelManager().getModelForEdit(facesConfigFile);
//			}
//			catch (IOException ioe)
//			{
//				return;
//			}
//			catch (CoreException ce)
//			{
//				return;
//			}
//			
//			final NewJavaManagedBeanWizard  wizard = new NewJavaManagedBeanWizard(_project);
//			final ManagedBeanConfiguration managedBeanConfig = new ManagedBeanConfiguration();
//			managedBeanConfig.setName(_messageText);
//	
//			IWorkbenchWindow workbenchWindow = EditorPlugin
//				.getActiveWorkbenchWindow();
//			final Shell shell;
//	
//			if (workbenchWindow.getShell() != null) {
//				shell = workbenchWindow.getShell();
//			} else {
//				shell = new Shell();
//			}
//	
//			final IStructuredModel modelAlias = model;
//			
//			shell.getDisplay().syncExec(new Runnable()
//			{
//				public void run()
//				{
//					wizard.init(PlatformUI.getWorkbench(), new StructuredSelection(new WizardAdapter(modelAlias, _project, managedBeanConfig)));
//		
//					wizard.setForcePreviousAndNextButtons(true);
//		
//					WizardDialog wizardDialog = new WizardDialog(shell, wizard);
//					wizardDialog.create();
//					
//					try
//					{
//						if (wizardDialog.open() == WizardDialog.OK)
//						{
//							modelAlias.save();
//						}
//					}
//					catch (IOException ioe)
//					{
//						System.err.println(ioe);
//					}
//					catch (CoreException coe)
//					{
//						System.err.println(coe);
//					}
//				}
//			});
//		}
//		finally
//		{
//			if (model != null)
//			{
//				model.releaseFromEdit();
//			}
//		}
	}

	public Point getSelection(IDocument document) {
		return null;
	}

	public String getAdditionalProposalInfo() {
		return null;
	}

	public String getDisplayString() 
	{
		final String displayString = Activator.getResourceString("QF_NEW_BEAN_PROPOSAL");
		return MessageFormat.format(displayString, new Object[]{_messageText});
	}

	public Image getImage() {
		// TODO: cache this resource
		ImageDescriptor descriptor = Activator.getDefault().getImageDescriptor("ManagedBeanType.gif");
		
		if (descriptor != null)
		{
			return descriptor.createImage();
		}

		return null;
	}

	public IContextInformation getContextInformation() {
		return new MyContextInformation();
	}

	private static class MyContextInformation implements IContextInformation
	{
		public String getContextDisplayString() {
			return "chicken on a bun, chieb sieb";
		}

		public Image getImage() {
			return null;
		}

		public String getInformationDisplayString() {
			return "chicken on a bun";
		}
		
	}
	
//	private static class WizardAdapter implements IAdaptable
//	{
//		private final IStructuredModel		_model;
//		private final IProject				_project;
//		private final ManagedBeanConfiguration _managedBeanConfig;
//		
//		/**
//		 * @param model
//		 * @param project
//		 * @param managedBeanConfig
//		 */
//		public WizardAdapter(IStructuredModel model, IProject project, ManagedBeanConfiguration managedBeanConfig)
//		{
//			_model = model;
//			_project = project;
//			_managedBeanConfig = managedBeanConfig;
//		}
//		
//		public Object getAdapter(Class adapter) 
//		{
//			if (IStructuredModel.class.equals(adapter))
//			{
//				return _model;
//			}
//			else if (IResource.class.equals(adapter))
//			{
//				return _project;
//			}
//			else if (String.class.equals(adapter))
//			{
//				return _managedBeanConfig.getName(); //_managedBeanConfig;
//			}
//			
//			return null;
//		}
//	}

}
